<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://unpkg.com/vue@next"></script>
    <title>Component</title>
</head>

<body>
    <div id="button-counter">
        <button @click="counter++">{{counter}}</button>
    </div>
    <script>
        const ButtonCounter = {
            data() {
                return {
                    counter: 0
                }
            }
        }
        Vue.createApp(ButtonCounter).mount("#button-counter")
    </script>

    <div id="app">
        <button-counter begin="1"></button-counter>
        <button-counter begin="2"></button-counter>
        <button-counter begin="3"></button-counter>
        <button-counter begin="4"></button-counter>
    </div>
    <script>
        const App = {
            data() {
                return {}
            }
        }
        const vue = Vue.createApp(App)
        vue.component("button-counter", {
            props: ['begin'],
            data() {
                return {
                    counter: this.begin
                }
            },
            template: `
                <button @click="counter++">{{counter}}</button>
            `
        })
        vue.mount("#app")
    </script>
</body>

</html>